varying vec3 normal, ecPos;
uniform bool Textured;
uniform sampler2D Tex0;

void main (void)
{
	vec3 n, lightDir;
	float NdotL;

	vec4 colorMap = texture2D(Tex0, gl_TexCoord[0].st);

	n = normalize(normal);
	lightDir = normalize(gl_LightSource[0].position.xyz - ecPos);
	NdotL = dot(n, lightDir);

	if (NdotL > 0.95)
		gl_FragData[0] = vec4(1.0);
	else if (NdotL > 0.5)
		gl_FragData[0] = vec4(0.75);
	else if (NdotL > 0.25)
		gl_FragData[0] = vec4(0.5);
	else if (NdotL > 0.0)
		gl_FragData[0] = vec4(0.25);

	if (Textured)
		gl_FragData[0] *= colorMap;

	gl_FragData[1] = vec4(n, 1.0);
}
